# Salary change and bonus employee notification script



## Background

This script came to be following a request from the People team to automate the filling out of letter templates with data from a spreadsheet and email them out to employee managers.

##  What you need to run it
* Python3 installed
* Command line
* .env file with login credentials to the [no-reply email](https://start.1password.com/open/i?a=BVGWOEO4GVG3XM2U3VNERI2WF4&v=2n5wwia3jl35irblzaecqozvga&i=45abff2zzixvyzbkhkmmbitwbe&h=cmrsurgical.1password.eu):
    * SENDER_EMAIL=email@cmrsurgical.com
    * PASSWORD=passwordfrom1pass

## Prepare the data
* Ensure all the necessaty templates and spreadsheets are in the root folder and they have equivalent names:
    * bonus_letter_with_shares.docx
    * bonus_letter_with_shares.xlxs

This is necessary as the code maps a sheet to a template so it can populated. Any non-matching filenames will not be processed in order to avoid embarrasing moments like an employee receiving a letter with a bonus/salary raise wildly different than expected.

## Running the script
1. First navigate to the correct directory
```
cd root_folder
```

2. Create a virtual environment
```
python3 -m venv venv
```

3. Activate the virtual environment
* For windows cmd
```
.\venv\Scripts\Activate
```

* For *nix environments
```
source ./venv/bin/activate
```

4. Install requirements
```
pip install -r requirements.txt
```

5. Run the script
```
python reviews.py
```

## Installation caveat
1. You may need to downgrade your version of pip after activating the virtual environment in step 3. These errors are related to lxml.
```
python -m pip install --upgrade pip==22.0.4
```

2. Download the correct version of [lxml](https://pypi.org/project/lxml/4.9.0/#files).

3. Place it in the same directory and install it.
```
pip install lxml-4.9.0-cp311-cp311-win_amd64.whl
```

## How it works
The scripts works on the assumption that there is a corresponding template to every spreadsheet with an identical filename.

1. Goes through the directory and creates sorted lists that have the templates and sheets respectively.

2. Creates a mapping of template:sheet if there are two files with the same filename, but different file extensions.

3. Goes through every mapping and checks the data:
    * Creating a new directory for a manager if there isn't one
    * Fills out the docx template
    * Converts docx template into a pdf
    * Removes docx template

4. Emails managers with all the employee letters they have.

5. Move pdf files into one folder for upload to hr archive
```
Get-ChildItem -Path "C:\Users\john.doe\Documents\salary-bonus-main" -Recurse -File | Move-Item -Destination "C:\Users\john.doe\Documents\salary-bonus-main/All_letters"
```



<!-- ## Test and Deploy

Use the built-in continuous integration in GitLab.

- [ ] [Get started with GitLab CI/CD](https://docs.gitlab.com/ee/ci/quick_start/index.html)
- [ ] [Analyze your code for known vulnerabilities with Static Application Security Testing(SAST)](https://docs.gitlab.com/ee/user/application_security/sast/)
- [ ] [Deploy to Kubernetes, Amazon EC2, or Amazon ECS using Auto Deploy](https://docs.gitlab.com/ee/topics/autodevops/requirements.html)
- [ ] [Use pull-based deployments for improved Kubernetes management](https://docs.gitlab.com/ee/user/clusters/agent/)
- [ ] [Set up protected environments](https://docs.gitlab.com/ee/ci/environments/protected_environments.html)

*** -->
<!-- 
# Editing this README

When you're ready to make this README your own, just edit this file and use the handy template below (or feel free to structure it however you want - this is just a starting point!).  Thank you to [makeareadme.com](https://www.makeareadme.com/) for this template.

## Suggestions for a good README
Every project is different, so consider which of these sections apply to yours. The sections used in the template are suggestions for most open source projects. Also keep in mind that while a README can be too long and detailed, too long is better than too short. If you think your README is too long, consider utilizing another form of documentation rather than cutting out information.

## Name
Choose a self-explaining name for your project.

## Description
Let people know what your project can do specifically. Provide context and add a link to any reference visitors might be unfamiliar with. A list of Features or a Background subsection can also be added here. If there are alternatives to your project, this is a good place to list differentiating factors.

## Badges
On some READMEs, you may see small images that convey metadata, such as whether or not all the tests are passing for the project. You can use Shields to add some to your README. Many services also have instructions for adding a badge.

## Visuals
Depending on what you are making, it can be a good idea to include screenshots or even a video (you'll frequently see GIFs rather than actual videos). Tools like ttygif can help, but check out Asciinema for a more sophisticated method.

## Installation
Within a particular ecosystem, there may be a common way of installing things, such as using Yarn, NuGet, or Homebrew. However, consider the possibility that whoever is reading your README is a novice and would like more guidance. Listing specific steps helps remove ambiguity and gets people to using your project as quickly as possible. If it only runs in a specific context like a particular programming language version or operating system or has dependencies that have to be installed manually, also add a Requirements subsection.

## Usage
Use examples liberally, and show the expected output if you can. It's helpful to have inline the smallest example of usage that you can demonstrate, while providing links to more sophisticated examples if they are too long to reasonably include in the README.

## Support
Tell people where they can go to for help. It can be any combination of an issue tracker, a chat room, an email address, etc.

## Roadmap
If you have ideas for releases in the future, it is a good idea to list them in the README.

## Contributing
State if you are open to contributions and what your requirements are for accepting them.

For people who want to make changes to your project, it's helpful to have some documentation on how to get started. Perhaps there is a script that they should run or some environment variables that they need to set. Make these steps explicit. These instructions could also be useful to your future self.

You can also document commands to lint the code or run tests. These steps help to ensure high code quality and reduce the likelihood that the changes inadvertently break something. Having instructions for running tests is especially helpful if it requires external setup, such as starting a Selenium server for testing in a browser. -->

## Authors and acknowledgment
Denis Barbov


## Project status
Mostly complete, unit tests to be implemented.
